SystemOrganization addCategory: #KEGGeneratorPost001FakeNewTest!

!KEGAbstractGeneratorTest methodsFor: '*KEGGeneratorPost001FakeNewTest' stamp: 'KjellGodo 4/9/2013 19:42'!
testgenerators "generators"

	"Method Version: keg2.  "
	" Copyright Kjell E God 20020507"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20020803, 20020507"
	"<< OWNER-: Kjell E God SOFTWARE-: picoVerse VERSION-: 2 >>""
	| ""answer"" notLastYet next |
							""MT b:#generators s:self.""
	""answer :=""
	^KEGAbstractGenerator new 
		firstBlock:[ notLastYet := true . next := self ]
		nextBlock:[ 
			notLastYet ifTrue:[
				( ( next := next generator )
					ifNil:[ true ]
					ifNotNil:[ :n | n isOnAStream ]
				)ifTrue:[ notLastYet := false ] . ""<---( causes the next return from ( answer next ) to be nil.  Which causes all future returns from ( answer next ) to be nil until the answer is reset via ( answer reset ). )""
				next
			]
		] .
							""MT e:#generators s:self."
	"^answer ."
	"Return a sequence of <self h1 h2 h3 h4 ... hL> where h1 is the Generator that
	feeds into self and h2 is the Generator that feeds into h1 and h3 is the Generator
	that feeds into h2 etc where hL is the last headwaters Generator and is often on
	a Stream.  The hi are call headwaters Generators because each h(i) feeds into
	h(i-1) like a creek where each pond in the creek feeds into the next pond.
	(|KEG2-<D:20020802>-: added the ifNil:ifNotNil: so that Generators that are
	not based on a Stream don't blow up.  Example-: FileStream>>asGenerator . )

	(| source-:( self( this method ) is supposed to come from the-:(
		C:\Kris\Kjell\Smalltalk\Dolphin\Images\InUse\KEGFakeGeneratorMethods.st
	) file. ) )-source

	"
	( self assert:(
		#(  ) asGenerator ifNotNil:[ :g | ( g collect:[ :x | x ] ) generators last == g ]
		) description:( '#(  ) asGenerator ifNotNil:[ :g | ( g collect:[ :x | x ] ) generators last == g ]' ) ).

	( self assert:(
		#(  ) asGenerator ifNotNil:[ :g | (( g collect:[ :x | x ] ) collect:[ :x | x ] ) generators last == g ]
		) description:( '#(  ) asGenerator ifNotNil:[ :g | (( g collect:[ :x | x ] ) collect:[ :x | x ] ) generators last == g ]' ) ).

	( self assert:(
		#(  ) asGenerator ifNotNil:[ :g | ((( g collect:[ :x | x ] ) collect:[ :x | x ] ) collect:[ :x | x ] ) generators last == g ]
		) description:( '#(  ) asGenerator ifNotNil:[ :g | ((( g collect:[ :x | x ] ) collect:[ :x | x ] ) collect:[ :x | x ] ) generators last == g ]' ) ).

! !

!KEGAbstractGeneratorTest methodsFor: '*KEGGeneratorPost001FakeNewTest' stamp: 'KjellGodo 4/9/2013 19:50'!
testheadWaters "headWaters"

	"Method Version: keg2.  "
	" Copyright Kjell E God 20020507"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20020803, 20020507"
	"<< OWNER-: Kjell E God SOFTWARE-: picoVerse VERSION-: 2 >>"
							"MT b:#headWaters s:self.""

	( headWaters ifNil:[ 
		( headWaters := WeakArray new:( 1 ) ).
		( ( self isOnAStream ) or:[ self generator isNil ] )
			ifTrue:[ headWaters at:1put: self ] ""<---[ Could cause memory leak if we don't use WeakArray ]""
			ifFalse:[ headWaters at:1put:( self generators last ) ]
	] ).
							""MT e:#headWaters s:self.""
	^headWaters at:1 .
	""Go up the list of head waters Generators that feed into self until we get to the
	very last headWaters of self which is assumed to be on a Stream.
	Return the very last headWaters Generator.  For an example of the usage of self(
	this method ) please see-:( 
		KEGAbstractGenerator>>on: 
		KEGStringGenerator>>lineWords
		PositionableStream>>superSubStrings
		KEGTransaction>>between:and:
		KEGNetscape4ETradeStockTrade>>fromString:
	)-see
	(|KEG2-<D:20020803>-:
			 	Changed-:( '( self isOnAStream )' )
				to-:( '( ( self isOnAStream ) or:[ self generator isNil ] )' )
		so that the case where a Generator is not based on a Stream ( in the generator
		instance variable ) will not blow up.  Example-: FileStream>>asGenerator . )

	( [_]: Rebuild self( this comment ) since it got accidentally deleted this morning.
		<D:20020508> )

	(| source-:( self( this method ) is supposed to come from the-:(
		C:\Kris\Kjell\Smalltalk\Dolphin\Images\InUse\KEGFakeGeneratorMethods.st
	) file. ) )-source

	"
	( self assert:(
		#(  ) asGenerator ifNotNil:[ :g | ( g collect:[ :x | x ] ) headWaters == g ]
		) description:( '#(  ) asGenerator ifNotNil:[ :g | ( g collect:[ :x | x ] ) headWaters == g ]' ) ).

	( self assert:(
		#(  ) asGenerator ifNotNil:[ :g | (( g collect:[ :x | x ] ) collect:[ :x | x ] ) headWaters == g ]
		) description:( '#(  ) asGenerator ifNotNil:[ :g | (( g collect:[ :x | x ] ) collect:[ :x | x ] ) headWaters == g ]' ) ).

	( self assert:(
		#(  ) asGenerator ifNotNil:[ :g | ((( g collect:[ :x | x ] ) collect:[ :x | x ] ) collect:[ :x | x ] ) headWaters == g ]
		) description:( '#(  ) asGenerator ifNotNil:[ :g | ((( g collect:[ :x | x ] ) collect:[ :x | x ] ) collect:[ :x | x ] ) headWaters == g ]' ) ).

! !

!KEGAbstractGeneratorTest methodsFor: '*KEGGeneratorPost001FakeNewTest' stamp: 'KjellGodo 4/9/2013 19:53'!
testonC "on: aCollection"

	"Method Version: keg1.  "
	" Copyright Kjell E God 20020507"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20020507"
	"<< OWNER-: Kjell E God SOFTWARE-: picoVerse VERSION-: 1 >>""
	| answer |
							""MT b:#on: s:self."
	"answer :=" "
	^( ( answer := self headWaters ) isOnAStream )
		ifTrue:[ 
			( answer == self )
				ifTrue:[ super on: aCollection ]
				ifFalse:[ answer on: aCollection ]
		] .
							""MT e:#on: s:self."
	"^answer ."
	"Go up the list of head waters Generators that feed into self until we get to the
	very last headWaters of self which is assumed to be on a Stream.  And then make
	the Stream be on aCollection and reinitialize the Stream to fit the new Collection.
	Return the very last headWaters Generator in the case aCollection was inserted
	into the headWaters Generator or nil otherwise( In which case the caller can call
	self>>headWaters to find out what the heck is going on with it. ).

	"
	( self assert:(
		#(  ) asGenerator ifNotNil:[ :g | (( g collect:[ :x | x + 1 ] ) on: #(  ) ; yourself ) asArray = #(  ) ]
		) description:( '#(  ) asGenerator ifNotNil:[ :g | (( g collect:[ :x | x + 1 ] ) on: #(  ) ; yourself ) asArray = #(  ) ]' ) ).

	( self assert:(
		#(  ) asGenerator ifNotNil:[ :g | (( g collect:[ :x | x + 1 ] ) on: #( 1 ) ; yourself ) asArray = #( 2 ) ]
		) description:( '#(  ) asGenerator ifNotNil:[ :g | (( g collect:[ :x | x + 1 ] ) on: #( 1 ) ; yourself ) asArray = #( 2 ) ]' ) ).

	( self assert:(
		#(  ) asGenerator ifNotNil:[ :g | (( g collect:[ :x | x + 1 ] ) on: #( 1 2 3 ) ; yourself ) asArray = #( 2 3 4 ) ]
		) description:( '#(  ) asGenerator ifNotNil:[ :g | (( g collect:[ :x | x + 1 ] ) on: #( 1 2 3 ) ; yourself ) asArray = #( 2 3 4 ) ]' ) ).

	( self assert:(
		#(  ) asGenerator ifNotNil:[ :g | ((( g collect:[ :x | x ] ) collect:[ :x | x + 1 ] ) on: #( 1 2 3 ) ; yourself ) asArray = #( 2 3 4 ) ]
		) description:( '#(  ) asGenerator ifNotNil:[ :g | ((( g collect:[ :x | x ] ) collect:[ :x | x + 1 ] ) on: #( 1 2 3 ) ; yourself ) asArray = #( 2 3 4 ) ]' ) ).

	( self assert:(
		KEGGenerator streamGenerator ifNotNil:[ :g | (((( g collect:[ :x | x ] ) collect:[ :x | x ] ) collect:[ :x | x + 1 ] ) on: #(  ) ; yourself ) asArray = #(  ) ]
		) description:( 'KEGGenerator streamGenerator ifNotNil:[ :g | (((( g collect:[ :x | x ] ) collect:[ :x | x ] ) collect:[ :x | x + 1 ] ) on: #(  ) ; yourself ) asArray = #(  ) ]' ) ).

	( self assert:(
		KEGGenerator streamGenerator ifNotNil:[ :g | (((( g collect:[ :x | x ] ) collect:[ :x | x ] ) collect:[ :x | x + 1 ] ) on: #( 1 2 3 ) ; yourself ) asArray = #( 2 3 4 ) ]
		) description:( 'KEGGenerator streamGenerator ifNotNil:[ :g | (((( g collect:[ :x | x ] ) collect:[ :x | x ] ) collect:[ :x | x + 1 ] ) on: #( 1 2 3 ) ; yourself ) asArray = #( 2 3 4 ) ]' ) ).

	( self assert:(
		KEGGenerator streamGenerator ifNotNil:[ :g | (((( g collect:[ :x | x ] ) collect:[ :x | x ] ) collect:[ :x | x + 1 ] ) on: #( 1 2 3 ) ; yourself ) asOrderedCollection asArray = #( 2 3 4 ) ]
		) description:( 'KEGGenerator streamGenerator ifNotNil:[ :g | (((( g collect:[ :x | x ] ) collect:[ :x | x ] ) collect:[ :x | x + 1 ] ) on: #( 1 2 3 ) ; yourself ) asOrderedCollection asArray = #( 2 3 4 ) ]' ) ).
! !

!KEGAbstractGeneratorTest methodsFor: '*KEGGeneratorPost001FakeNewTest' stamp: 'KjellGodo 4/9/2013 19:56'!
"(| defineMethod-:(" testonGeneratorC "onGenerator: aGenerator "")
	notes-:(		Method Version: keg2.
				 Copyright Kjell E God 20051230
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20130203 21:08 ) 20051230
	<< OWNER-: Kjell E God SOFTWARE-: picoVerse VERSION-: 1 >>
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#onGenerator: s:self ).""
	^(	
		generator
			ifNil:[ self error: 'No KEGGenerator to connect to at end of Generator list' ] ""<---[ See note below ]""
			ifNotNil:[ :g | g onGenerator: aGenerator ]

	)""return:( 					MT e:#onGenerator: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Make the headwaters of self be aGenerator.
	aGenerator can be a Stream( see below ).

 )-summary
 methodDescriptionDetail-:(

	Go up the list of head waters Generators that feed into self 
	until we get to the very last headWaters G of self which is assumed
	to be of the KEGGenerator Class so that the >>generator: message
	above will work and then the G>>reset and G>>next messages will
	be redirected to aGenerator.  And then 
	replace the generator in G
	with aGenerator.  aGenerator can be anything that responds
	to both the >>reset and the >>next messages including
	Streams.
	Return aGenerator.

	This is how you can build up two Generators and then combine them
	later.  If A produces Generator GA and B produces Generator GB then
	GB onGenerator: GA
	is equivalent to
	( A B ) which is A followed by B so to speak, sort of. A creates GA and
	then B adds on to GA.  See the test cases below.

	You only have to create a Generator once and then you can reuse it
	in different ways by sticking another Generator onto it.

	But if you do ( GB onGenerator: GA ).( GB onGenerator: GC )
	you get ( C B ).  But with the alternate code below you would
	get ( C A B ) because the headWaters searches for the KEGGenerator
	on a Stream and there might not be one or it might be at the end of
	the list of Generators ( A B ).

	REMEMBER ( self headWaters ) cannot be a KEGAbstractGenerator
	because the 
	KEGAbstractGenerator>>reset and
	KEGAbstractGenerator>>next
	do not know about the generator instance variable( and won't for speed ).

	It is easy to get a new generic empty KEGGenerator by doing

	( KEGGenerator streamGenerator )

	that can be used for various things and as a base for making new
	Generators that can be reused using the
	KEGAbstractGenerator>>onGenerator: and
	KEGAbstractGenerator>>on: messages.

 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( 20130203 ) madeChanges-:( cut the alternate code below out and added code above and
		created KEGGenerator>>onGenerator: to stop the Generator list traversal easily )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:(
		#(  ) asGenerator ifNotNil:[ :g | (( g collect:[ :x | x + 1 ] ) onGenerator:( #(  ) asGen collect:[ :x | x + 1 ] ) ; yourself ) asArray = #(  ) ]
		) description:( '#(  ) asGenerator ifNotNil:[ :g | (( g collect:[ :x | x + 1 ] ) onGenerator:( #(  ) asGen collect:[ :x | x + 1 ] ) ; yourself ) asArray = #(  ) ]' ) ).

	( self assert:(
		#(  ) asGenerator ifNotNil:[ :g | (( g collect:[ :x | x + 1 ] ) onGenerator:( #( 1 ) asGen collect:[ :x | x + 1 ] ) ; yourself ) asArray = #( 3 ) ]
		) description:( '#(  ) asGenerator ifNotNil:[ :g | (( g collect:[ :x | x + 1 ] ) onGenerator:( #( 1 ) asGen collect:[ :x | x + 1 ] ) ; yourself ) asArray = #( 3 ) ]' ) ).

	( self assert:(
		#(  ) asGenerator ifNotNil:[ :g | (( g collect:[ :x | x + 1 ] ) onGenerator:( #( 1 2 3 ) asGen collect:[ :x | x + 1 ] ) ; yourself ) asArray = #( 3 4 5 ) ]
		) description:( '#(  ) asGenerator ifNotNil:[ :g | (( g collect:[ :x | x + 1 ] ) onGenerator:( #( 1 2 3 ) asGen collect:[ :x | x + 1 ] ) ; yourself ) asArray = #( 3 4 5 ) ]' ) ).

	( self assert:(
		#(  ) asGenerator ifNotNil:[ :g | ((( g collect:[ :x | x ] ) collect:[ :x | x + 1 ] ) onGenerator:( #( 1 2 3 ) asGen collect:[ :x | x + 1 ] ) ; yourself ) asArray = #( 3 4 5 ) ]
		) description:( '#(  ) asGenerator ifNotNil:[ :g | ((( g collect:[ :x | x ] ) collect:[ :x | x + 1 ] ) onGenerator:( #( 1 2 3 ) asGen collect:[ :x | x + 1 ] ) ; yourself ) asArray = #( 3 4 5 ) ]' ) ).

	( self assert:(
		#(  ) asGenerator ifNotNil:[ :g | (((( g collect:[ :x | x ] ) collect:[ :x | x ] ) collect:[ :x | x + 1 ] ) onGenerator:( #(  ) asGen collect:[ :x | x + 1 ] ) ; yourself ) asArray = #(  ) ]
		) description:( '#(  ) asGenerator ifNotNil:[ :g | (((( g collect:[ :x | x ] ) collect:[ :x | x ] ) collect:[ :x | x + 1 ] ) onGenerator:( #(  ) asGen collect:[ :x | x + 1 ] ) ; yourself ) asArray = #(  ) ]' ) ).

	( self assert:(
		KEGGenerator streamGenerator ifNotNil:[ :g | (((( g collect:[ :x | x ] ) collect:[ :x | x ] ) collect:[ :x | x + 1 ] ) onGenerator:( #( 1 2 3 ) asGen collect:[ :x | x + 1 ] ) ; yourself ) asArray = #( 3 4 5 ) ]
		) description:( 'KEGGenerator streamGenerator ifNotNil:[ :g | (((( g collect:[ :x | x ] ) collect:[ :x | x ] ) collect:[ :x | x + 1 ] ) onGenerator:( #( 1 2 3 ) asGen collect:[ :x | x + 1 ] ) ; yourself ) asArray = #( 3 4 5 ) ]' ) ).

	( self assert:(
		#(  ) asGenerator ifNotNil:[ :g | (((( g collect:[ :x | x ] ) collect:[ :x | x ] ) collect:[ :x | x + 1 ] ) onGenerator:( #( 1 2 3 ) asGen collect:[ :x | x + 1 ] ) ; yourself ) asOrderedCollection asArray = #( 3 4 5 ) ]
		) description:( '#(  ) asGenerator ifNotNil:[ :g | (((( g collect:[ :x | x ] ) collect:[ :x | x ] ) collect:[ :x | x + 1 ] ) onGenerator:( #( 1 2 3 ) asGen collect:[ :x | x + 1 ] ) ; yourself ) asOrderedCollection asArray = #( 3 4 5 ) ]' ) ).

	( self assert:(
		(( #(  ) asGen collect:[ :x | x ] ) onGenerator:( #( 1 2 3 ) asGen collect:[ :x | x - 1 ] ) ; onGenerator:( #( 1 2 3 ) asGen collect:[ :x | x + 1 ] ) ; yourself ) asArray = #( 2 3 4 )
		) description:( '(( #(  ) asGen collect:[ :x | x ] ) onGenerator:( #( 1 2 3 ) asGen collect:[ :x | x - 1 ] ) ; onGenerator:( #( 1 2 3 ) asGen collect:[ :x | x + 1 ] ) ; yourself ) asArray = #( 2 3 4 )' ) ).

	( self assert:(
		(( #(  ) asGen collect:[ :x | x ] ) onGenerator:( #( 1 2 3 ) readStream ) ; yourself ) asArray = #( 1 2 3 )
		) description:( '(( #(  ) asGen collect:[ :x | x ] ) onGenerator:( #( 1 2 3 ) readStream ) ; yourself ) asArray = #( 1 2 3 )' ) ).

 " )-testCases
 alternateCode-:(

		( self headWaters ) generator:( aGenerator )

 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !
